<?php
  class ot_openpaysr {
    var $title, $output;

    public function ot_openpaysr() {
      $this->code = 'ot_openpaysr';
      $this->title = MODULE_ORDER_TOTAL_OPENPAYSR_TITLE;
      $this->description = MODULE_ORDER_TOTAL_OPENPAYSR_DESC;
      $this->enabled = ((MODULE_ORDER_TOTAL_OPENPAYSR_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_ORDER_TOTAL_OPENPAYSR_SORT_ORDER;

      $this->output = array();
    }

    public function process() {
      global $order, $currencies;

      if (MODULE_ORDER_TOTAL_OPENPAYSR_STATUS != 'true') {
        return;
      }

      if( ! ereg( '^openpay_', $_SESSION['payment'] ) ):
        return;
      endif;

      if( array_key_exists('MODULE_ORDER_TOTAL_OPENPAYSR_PAYMETHOD', $_SESSION) ):
        $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_PAYMETHOD'] += 0;
      else:
        $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_PAYMETHOD'] = 0;
      endif;
      if( array_key_exists('MODULE_ORDER_TOTAL_OPENPAYSR_IID', $_SESSION) ):
        $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_IID'] += 0;
      else:
        $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_IID'] = 0;
      endif;

      switch( $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_PAYMETHOD'] ):
      case 1:
        switch( $_SESSION['MODULE_ORDER_TOTAL_OPENPAYSR_IID'] ):
          case 0:   $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD00_RATE; break;
          case 3:   $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD03_RATE; break;
          case 6:   $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD06_RATE; break;
          case 12:  $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD12_RATE; break;
          case 24:  $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD24_RATE; break;
          case 36:  $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CCARD36_RATE; break;
          default:  $arate = 0;
        endswitch;
        break;
      case 2: $arate = MODULE_ORDER_TOTAL_OPENPAYSR_VACCOUNT_RATE; break;
      case 4: $arate = MODULE_ORDER_TOTAL_OPENPAYSR_WEBATM_RATE; break;
      case 8: $arate = MODULE_ORDER_TOTAL_OPENPAYSR_CSTORE_RATE; break;
      case 9: $arate = MODULE_ORDER_TOTAL_OPENPAYSR_IBON_RATE; break;
      case 11:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_PAYPAL_RATE; break;
      case 12:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_FAMI_RATE; break;
      case 13:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_ALI_RATE; break;
      case 14:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_TEN_RATE; break;
      case 15:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_CTNB_RATE; break;
      case 16:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_PCSCCOD_RATE; break;
      case 17:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_UPOP_RATE; break;
      case 18:$arate = MODULE_ORDER_TOTAL_OPENPAYSR_APPAY_RATE; break;
      default: $arate = 0;
      endswitch;

      if ($arate <= 0) {
        return;
      }

      $order->info['ori_total'] = $order->info['total'];
      if( $arate >= 1 ) {
        $surcharge = $arate;
        $title = $this->title . '($' . $arate . '):';
      } else {
        $surcharge = round( $order->info['ori_total'] * $arate );
        $title = $this->title . '(' . round($arate*100) . '%):';
      }
      $order->info['total'] = $order->info['ori_total'] + $surcharge;

      $this->output[] = array(
        'title' => $title,
        'text'  => $currencies->format($surcharge, true, $order->info['currency'], $order->info['currency_value']),
        'value' => $surcharge);
    }

    public function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_OPENPAYSR_STATUS'");
        $this->_check = $check_query->RecordCount();
      }

      return $this->_check;
    }

    public function keys() {
      return array('MODULE_ORDER_TOTAL_OPENPAYSR_STATUS', 'MODULE_ORDER_TOTAL_OPENPAYSR_SORT_ORDER',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD00_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD03_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD06_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD12_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD24_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CCARD36_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CSTORE_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_IBON_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_VACCOUNT_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_WEBATM_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_PAYPAL_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_FAMI_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_ALI_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_TEN_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_CTNB_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_PCSCCOD_RATE',
        'MODULE_ORDER_TOTAL_OPENPAYSR_UPOP_RATE', 'MODULE_ORDER_TOTAL_OPENPAYSR_APPAY_RATE' );
    }

    public function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_STATUS', 'true', '6', '1','twe_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_SORT_ORDER', '98', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD00_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD03_RATE', '0.05', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD06_RATE', '0.65', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD12_RATE', '0.11', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD24_RATE', '0.18', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CCARD36_RATE', '0.20', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CSTORE_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_IBON_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_PAYPAL_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_VACCOUNT_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_WEBATM_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_FAMI_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_ALI_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_TEN_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_CTNB_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_PCSCCOD_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_UPOP_RATE', '0', '6', '5', '', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, date_added) values ('MODULE_ORDER_TOTAL_OPENPAYSR_APPAY_RATE', '0', '6', '5', '', now())");
    }

    public function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
