<?php

require_once( dirname(__FILE__).'/openpay_config.php' );

class openpay_main {
  public static function get_form_action_url() { return 'https://www.twv.com.tw/openpay/pay.php'; }

  private static function _get_order_amount( $order ) {
    if( ($_SESSION['customers_status']['customers_status_show_price_tax'] == 0)
     && ($_SESSION['customers_status']['customers_status_add_tax_ot'] == 1) ) {
      $amount = round($order->info['total']+$order->info['tax']);
    } else {
      $amount = round($order->info['total']);
    }

    return $amount;
  }

  public static function get_request_parameter( $prefer_paymethod, $iid, $return_url, $order, $language ) {
    $params['version']    = '2.1';
    $params['mid']        = MODULE_PAYMENT_OPENPAY_MID;
    $params['prefer_paymethod'] = $prefer_paymethod;
    $params['iid']        = $iid;
    $params['txid']       = date("YmdHis");
    $params['amount']     = openpay_main::_get_order_amount( $order );
    $params['verify']     = md5(implode( '|', array(MODULE_PAYMENT_OPENPAY_KEY1, MODULE_PAYMENT_OPENPAY_MID, $params['txid'], $params['amount'], MODULE_PAYMENT_OPENPAY_KEY2) ));
    $params['return_url'] = $return_url;
    $params['cart_type']  = 'twecommerce2.2-utf8-openpay2.1.10';


    // name/address representation for chinese/others
    switch( $language ) {
    case 'english':
      $params['language'] = 'english';
      $params['charset']  = 'UTF-8';

      $params['cname']    = $order->customer['firstname'] .' ' .$order->customer['lastname'];
      $params['caddress'] = $order->customer['street_address'] .', ' .$order->customer['suburb'] .', ' .$order->customer['city'] .', ' .$order->customer['state'] .' ' .$order->customer['postcode'] .', ' .$order->customer['country']['title'];

      $params['xname']    = $order->delivery['firstname'] .' ' .$order->delivery['lastname'];
      $params['xaddress'] = $order->delivery['street_address'] .', ' .$order->delivery['suburb'] .', ' .$order->delivery['city'] .', ' .$order->delivery['state'] .' ' .$order->delivery['postcode'] .', ' .$order->delivery['country']['title'];
      break;
    case 'tchinese':
    default:
      $params['language'] = 'tchinese';
      $params['charset']  = 'UTF-8';

      $params['cname']    = $order->customer['firstname'];
      $params['caddress'] = $order->customer['postcode'] .$order->customer['state'] .$order->customer['city'] .$order->customer['suburb'] .$order->customer['street_address'];

      $params['xname']    = $order->delivery['firstname'];
      $params['xaddress'] = $order->delivery['postcode'] .$order->delivery['state'] .$order->delivery['city'] .$order->delivery['suburb'] .$order->delivery['street_address'];
      break;
    }
    $params['ctel']   = $order->customer['telephone'];
    $params['cemail'] = $order->customer['email_address'];
    $local_language   = 'UTF-8';


    $_SESSION['MODULE_PAYMENT_OPENPAY'][$params['txid']] = array(
      'req_params' => $params,
      'local_language' => $local_language );

    return $params;
  }

  public static function do_response_process( $res_params, & $order, $code ) {
    // load session data
    $req_params = array();
    $local_language = 'UTF-8';
    if( array_key_exists( 'txid', $res_params )
     && array_key_exists( $res_params['txid'], $_SESSION['MODULE_PAYMENT_OPENPAY'] ) ) {
      $sinfo = $_SESSION['MODULE_PAYMENT_OPENPAY'][$res_params['txid']];
      $req_params = $sinfo['req_params'];
      $local_language = $sinfo['local_language'];
    }

    // render/check verify string
    $plain_text = implode( '|', array(MODULE_PAYMENT_OPENPAY_KEY1, $req_params['txid'], $req_params['amount'], $res_params['pay_type'], $res_params['status'], $res_params['tid'], MODULE_PAYMENT_OPENPAY_KEY2) );
    $verify = md5( $plain_text );

    if( $res_params['verify'] != $verify ) {
      openpay_main::payment_error( 'payment_error='.$code.'&error=1' );
    }

    // check payment pay_type/status
    switch( $res_params['status'] ) {
    case '1':
    case '3':
      break;
    case '2':
      $error_desc = $res_params['error_desc'];
      if( function_exists( 'mb_convert_encoding' ) ) {
        $error_desc = mb_convert_encoding( $error_desc, $local_language, "UTF-8" );
      }

      openpay_main::payment_error( 'payment_error='.$code .'&error=2&error_desc='.rawurlencode($error_desc) );
      break;
    default:
      openpay_main::payment_error( 'payment_error='.$code );
    }


    switch( $res_params['pay_type'] ) {
    case 1:   $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_CCARD; break;
    case 2:   $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_VACCOUNT; break;
    case 4:   $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_WEBATM; break;
    case 8:   $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_CSTORE; break;
    case 9:   $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_IBON; break;
    case 11:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_PAYPAL; break;
    case 12:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_FAMI; break;
    case 13:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_ALI; break;
    case 14:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_TEN; break;
    case 16:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_PCSCCOD; break;
    case 17:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_UPOP; break;
    case 18:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_APPAY; break;
    default:  $pay_type = MODULE_PAYMENT_OPENPAY_TEXT_PAYTYPE_UNKNOWN .'('.$res_params['pay_type'].')';
    }

    switch( $res_params['status'] ) {
    case 1:   $status = MODULE_PAYMENT_OPENPAY_TEXT_STATUS_SUCCESS; break;
    case 3:   $status = MODULE_PAYMENT_OPENPAY_TEXT_STATUS_WAITING; break;
    default:  $status = MODULE_PAYMENT_OPENPAY_TEXT_STATUS_UNKNOWN .'('.$res_params['status'].')';
    }

    $order->info['cc_type']   = $pay_type;
    $order->info['cc_owner']  = $status;
    $order->info['cc_number'] = MODULE_PAYMENT_OPENPAY_TEXT_TID.$res_params['tid'];
  }

  public static function payment_error( $url_appendix ) {
    twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $url_appendix, 'SSL', true, false));
  }

  public static function get_error( $error_id, $error_desc ) {
    switch( $error_id ) {
    case '1': $error = MODULE_PAYMENT_OPENPAY_TEXT_ERROR_1; break;
    case '2': $error = MODULE_PAYMENT_OPENPAY_TEXT_ERROR_2.'('.$error_desc.')'; break;
    default:  $error = MODULE_PAYMENT_OPENPAY_TEXT_ERROR_OTHERS; break;
    }

    $error = array('title' => MODULE_PAYMENT_OPENPAY_TEXT_ERROR,
                   'error' => MODULE_PAYMENT_OPENPAY_TEXT_ERROR.':'.$error);
    return $error;
  }
}
